/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Controller;

import DataEntryBean.PdsSellItemEntryBean;
import LoginDb.DbHandler;
import java.io.IOException;
import java.io.PrintWriter;
import java.lang.reflect.InvocationTargetException;
import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.StringTokenizer;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import org.apache.commons.beanutils.BeanUtils;
import LoginDb.DbHandler;
import java.io.IOException;
import java.io.PrintWriter;
import java.lang.reflect.InvocationTargetException;
import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.StringTokenizer;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import org.apache.commons.beanutils.BeanUtils;

/**
 *
 * @author 986137
 */
public class pdssaleitemEntry extends HttpServlet {

    /** 
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        HttpSession session = request.getSession(false);
        String handle_id = request.getParameter("handle_id");
        String optionValue = request.getParameter("checkOption");
        Connection con = null;
        CallableStatement proc = null;
        String message = "";
        String pacsId = (String) session.getAttribute("pacsId");
        String user = (String) session.getAttribute("user");
        PdsSellItemEntryBean PdsSellItemEntryBeanObj = new PdsSellItemEntryBean();
        String hdrID = "";
        ArrayList<PdsSellItemEntryBean> alPdsSellItemEntryBean = new ArrayList<PdsSellItemEntryBean>();
        BatchExecutionFailedOperation BatchExecutionFailedOperationObject=new BatchExecutionFailedOperation();
        boolean SuccessFlag;
        String memberId=null;

        if (handle_id.equalsIgnoreCase("Create")) {


            try {
                //BeanUtils.populate(PdsSellItemEntryBeanObj, request.getParameterMap());
                memberId=PdsSellItemEntryBeanObj.getMemberId();
            } catch (IllegalAccessException ex) {
               // Logger.getLogger(VendorMasterServlet.class.getName()).log(Level.SEVERE, null, ex);
               System.out.println("Error occurred during processing.");
            } catch (InvocationTargetException ex) {
               // Logger.getLogger(VendorMasterServlet.class.getName()).log(Level.SEVERE, null, ex);
               System.out.println("Error occurred during processing.");
            }

            try {
                con = DbHandler.getDBConnection();
                try {
                    proc = con.prepareCall("{ call PDS_operations.insert_pds_sales_hdr(?,?,?,?,?) }");
                } catch (SQLException ex) {
                   // Logger.getLogger(VendorMasterServlet.class.getName()).log(Level.SEVERE, null, ex);
                   System.out.println("Error occurred during processing.");
                }

                proc.setString(1, PdsSellItemEntryBeanObj.getMemberId());
                proc.setString(2, PdsSellItemEntryBeanObj.getGrandTotal());
                proc.setString(3, pacsId);
                proc.registerOutParameter(4, java.sql.Types.VARCHAR);
                proc.registerOutParameter(5, java.sql.Types.VARCHAR);

                proc.execute();

                //message = proc.getString(4);
                //hdrID = proc.getString(5);



            } catch (SQLException ex) {

               // Logger.getLogger(VendorMasterServlet.class.getName()).log(Level.SEVERE, null, ex);
               System.out.println("Error occurred during processing.");
            } finally {
                try {
                    proc.close();
                } catch (SQLException e) {
                    System.out.println("Error occurred during proc close.");
                }
                try {
                    con.close();
                } catch (SQLException ex) {
                   // Logger.getLogger(VendorMasterServlet.class.getName()).log(Level.SEVERE, null, ex);
                   System.out.println("Error occurred during connection close.");
                }

            }
            int counter = Integer.parseInt(request.getParameter("rowCounter"));

            for (int i = 1; i <= counter; i++) {
                try {

                   // String productId = request.getParameter("product_id" + i);
                   // String p_order_id = request.getParameter("p_order_id" + i);
                   // String quantity = request.getParameter("quantity" + i);
                   // String price = request.getParameter("price" + i);



                    if (productId != null) {
                        PdsSellItemEntryBeanObj = new PdsSellItemEntryBean();
                        PdsSellItemEntryBeanObj.setProduct_id(productId);
                        PdsSellItemEntryBeanObj.setStockId(p_order_id);
                        PdsSellItemEntryBeanObj.setQuantity(quantity);
                        PdsSellItemEntryBeanObj.setPrice(price);
                        alPdsSellItemEntryBean.add(PdsSellItemEntryBeanObj);
                    }
                } catch (Exception e) {
                    System.out.println("Error occurred during processing.");
                }
            }
            if ((alPdsSellItemEntryBean.size() > 0) && (!message.equalsIgnoreCase("")) && (!hdrID.equalsIgnoreCase(""))) {

                try {
                    con = DbHandler.getDBConnection();
                    try {
                        proc = con.prepareCall("{ call PDS_operations.insert_pds_sales_dtl(?,?,?,?,?,?,?) }");
                    } catch (SQLException ex) {
                       // Logger.getLogger(VendorMasterServlet.class.getName()).log(Level.SEVERE, null, ex);
                       System.out.println("Error occurred during processing.");
                    }


                    for (int j = 0; j < alPdsSellItemEntryBean.size(); j++) {

                        PdsSellItemEntryBeanObj = alPdsSellItemEntryBean.get(j);


                        proc.setString(1, hdrID);
                        proc.setString(2, PdsSellItemEntryBeanObj.getStockId());
                        proc.setString(3, PdsSellItemEntryBeanObj.getProduct_id());
                        proc.setString(4, PdsSellItemEntryBeanObj.getQuantity());
                        proc.setString(5, PdsSellItemEntryBeanObj.getPrice());
                        proc.setString(6,memberId);
                        proc.setString(7,pacsId);
                        proc.addBatch();


                    }

                    proc.executeBatch();

                } catch (SQLException ex) {
                    try {
                       // con.rollback();
                        
                        SuccessFlag=BatchExecutionFailedOperationObject.BatchExecutionFailedOperation("PdsSellItem.jsp", hdrID);

                        message=ex.toString();


                    } catch (Exception ex1) {
                       // Logger.getLogger(TradingSaleItemEntry.class.getName()).log(Level.SEVERE, null, ex1);
                       System.out.println("Error occurred during processing.");
                    }
                   // Logger.getLogger(VendorMasterServlet.class.getName()).log(Level.SEVERE, null, ex);
                   // System.out.println(ex.toString());
                   System.out.println("Error occurred during processing.");
                } finally {
                    try {
                        proc.close();
                    } catch (SQLException e) {
                       // System.out.println(e.toString());
                       System.out.println("Error occurred during proc close.");
                    }
                    try {
                        con.close();
                    } catch (SQLException ex) {
                       // Logger.getLogger(VendorMasterServlet.class.getName()).log(Level.SEVERE, null, ex);
                       // System.out.println(ex.toString());
                       System.out.println("Error occurred during connection close.");
                    }
                }
            }




            request.setAttribute("message", message);
            request.setAttribute("requisitionId",hdrID);
            request.getRequestDispatcher("/Pds_JSP/PdsInvoice.jsp").forward(request, response);

        }
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>
}
